using UnityEngine;
using System.Collections;

public class Coin : MonoBehaviour 
{
	private CoinCounter coinCounter;
	public AudioClip coinSound;

	void Awake()
	{
		coinCounter = GameObject.Find("CoinCounter").GetComponent<CoinCounter>();
	}
	
	void OnTriggerEnter2D(Collider2D other)
	{
		if(other.gameObject.tag == "Player")
		{
			AudioSource.PlayClipAtPoint(coinSound, transform.position);
			print ("You picked up a coin!");
			//Set the coin to inactive
			gameObject.SetActive(false);
			//Update the GUI
			coinCounter.value++;
		}
	}
}