﻿using UnityEngine;
using System.Collections;

public class Enemy : MonoBehaviour
{
	public float moveSpeed = 2f;		// The speed the enemy moves at.
	//public int HP = 2;					// How many times the enemy can be hit before it dies.
	//public Sprite deadEnemy;			// A sprite of the enemy when it's dead.
	//public float deathSpinMin = -100f;			// A value to give the minimum amount of Torque when dying
	//public float deathSpinMax = 100f;			// A value to give the maximum amount of Torque when dying
	public LayerMask collideMask;

	//private SpriteRenderer ren;			// Reference to the sprite renderer.
	private Transform frontCheck;		// Reference to the position of the gameobject used for checking if something is in front.
	//private bool dead = false;			// Whether or not the enemy is dead.
	//private Animator anim;				// Reference to the player's animator component.


	void Awake()
	{
		// Setting up the references.
		//ren = this.GetComponent<SpriteRenderer>();
		frontCheck = transform.Find("FrontCheck");
		//anim = GetComponent<Animator>();
	}
	void FixedUpdate ()
	{

		// Create an array of all the colliders in front of the enemy.
		/*Collider2D[] frontHits = Physics2D.OverlapPointAll(frontCheck.position, collideMask);

		// Check each of the colliders.
		foreach(Collider2D c in frontHits)
		{
			// If any of the colliders is an Obstacle...
			if(c.tag == "Obstacle" || c.tag == "Enemy")
			{
				// ... Flip the enemy and stop checking the other colliders.
				Flip ();
			}

			if(c.tag == "Player")
			{
				//Apply Damage to player
				print ("I damaged the player!");
				break;
			}
		}
*/
		// Set the enemy's velocity to moveSpeed in the x direction.
		rigidbody2D.velocity = new Vector2(transform.localScale.x * moveSpeed, rigidbody2D.velocity.y);

		// If the enemy has one hit point left and has a damagedEnemy sprite...
		//if(HP == 1 && damagedEnemy != null)
			// ... set the sprite renderer's sprite to be the damagedEnemy sprite.
			//ren.sprite = damagedEnemy;
			
		// If the enemy has zero or fewer hit points and isn't dead yet...
		//if(HP <= 0 && !dead)
			// ... call the death function.
			//Death ();
	}
/*
	public void Hurt()
	{
		// Reduce the number of hit points by one.
		HP--;
	}
	
	void Death()
	{
		// Play the Death animator trigger parameter.
		anim.SetBool("Death", true);

		// Increase the score by 100 points
		//score.score += 100;

		// Set dead to true.
		dead = true;

		// Allow the enemy to rotate and spin it by adding a torque.
		rigidbody2D.fixedAngle = false;
		rigidbody2D.AddTorque(Random.Range(deathSpinMin,deathSpinMax));

		// Find all of the colliders on the gameobject and set them all to be triggers.
		Collider2D[] cols = GetComponents<Collider2D>();
		foreach(Collider2D c in cols)
		{
			c.isTrigger = true;
		}

		// Play a random audioclip from the deathClips array.
		//int i = Random.Range(0, deathClips.Length);
		//AudioSource.PlayClipAtPoint(deathClips[i], transform.position);

		// Create a vector that is just above the enemy.
		//Vector3 scorePos;
		//scorePos = transform.position;
		//scorePos.y += 1.5f;

		// Instantiate the 100 points prefab at this point.
		//Instantiate(hundredPointsUI, scorePos, Quaternion.identity);
	}

	*/
	public void Flip()
	{
		// Multiply the x component of localScale by -1.
		Vector3 enemyScale = transform.localScale;
		enemyScale.x *= -1;
		transform.localScale = enemyScale;
	}
}